CfnStackSet L1 construct
The AWS::CloudFormation::StackSet resource contains information about a StackSet.
With StackSets, you can provision stacks across AWS accounts and Regions from a single CloudFormation template. Each stack is based on the same CloudFormation template, but you can customize individual stacks using parameters.
Run deployments to nested StackSets from the parent stack, not directly through the StackSet API.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import * as cdk from 'aws-cdk-lib';
declare const managedExecution: any;
const cfnStackSet = new cdk.CfnStackSet(this, 'MyCfnStackSet', {
permissionModel: 'permissionModel',
stackSetName: 'stackSetName',
// the properties below are optional
administrationRoleArn: 'administrationRoleArn',
autoDeployment: {
dependsOn: ['dependsOn'],
enabled: false,
retainStacksOnAccountRemoval: false,
},
callAs: 'callAs',
capabilities: ['capabilities'],
description: 'description',
executionRoleName: 'executionRoleName',
managedExecution: managedExecution,
operationPreferences: {
concurrencyMode: 'concurrencyMode',
failureToleranceCount: 123,
failureTolerancePercentage: 123,
maxConcurrentCount: 123,
maxConcurrentPercentage: 123,
regionConcurrencyType: 'regionConcurrencyType',
regionOrder: ['regionOrder'],
},
parameters: [{
parameterKey: 'parameterKey',
parameterValue: 'parameterValue',
}],
stackInstancesGroup: [{
deploymentTargets: {
accountFilterType: 'accountFilterType',
accounts: ['accounts'],
accountsUrl: 'accountsUrl',
organizationalUnitIds: ['organizationalUnitIds'],
},
regions: ['regions'],
// the properties below are optional
parameterOverrides: [{
parameterKey: 'parameterKey',
parameterValue: 'parameterValue',
}],
}],
tags: [{
key: 'key',
value: 'value',
}],
templateBody: 'templateBody',
templateUrl: 'templateUrl',
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
import aws_cdk as cdk
# managed_execution: Any
cfn_stack_set = cdk.CfnStackSet(self, "MyCfnStackSet",
permission_model="permissionModel",
stack_set_name="stackSetName",
# the properties below are optional
administration_role_arn="administrationRoleArn",
auto_deployment=cdk.CfnStackSet.AutoDeploymentProperty(
depends_on=["dependsOn"],
enabled=False,
retain_stacks_on_account_removal=False
),
call_as="callAs",
capabilities=["capabilities"],
description="description",
execution_role_name="executionRoleName",
managed_execution=managed_execution,
operation_preferences=cdk.CfnStackSet.OperationPreferencesProperty(
concurrency_mode="concurrencyMode",
failure_tolerance_count=123,
failure_tolerance_percentage=123,
max_concurrent_count=123,
max_concurrent_percentage=123,
region_concurrency_type="regionConcurrencyType",
region_order=["regionOrder"]
),
parameters=[cdk.CfnStackSet.ParameterProperty(
parameter_key="parameterKey",
parameter_value="parameterValue"
)],
stack_instances_group=[cdk.CfnStackSet.StackInstancesProperty(
deployment_targets=cdk.CfnStackSet.DeploymentTargetsProperty(
account_filter_type="accountFilterType",
accounts=["accounts"],
accounts_url="accountsUrl",
organizational_unit_ids=["organizationalUnitIds"]
),
regions=["regions"],
# the properties below are optional
parameter_overrides=[cdk.CfnStackSet.ParameterProperty(
parameter_key="parameterKey",
parameter_value="parameterValue"
)]
)],
tags=[cdk.CfnTag(
key="key",
value="value"
)],
template_body="templateBody",
template_url="templateUrl"
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.*;
Object managedExecution;
CfnStackSet cfnStackSet = CfnStackSet.Builder.create(this, "MyCfnStackSet")
.permissionModel("permissionModel")
.stackSetName("stackSetName")
// the properties below are optional
.administrationRoleArn("administrationRoleArn")
.autoDeployment(AutoDeploymentProperty.builder()
.dependsOn(List.of("dependsOn"))
.enabled(false)
.retainStacksOnAccountRemoval(false)
.build())
.callAs("callAs")
.capabilities(List.of("capabilities"))
.description("description")
.executionRoleName("executionRoleName")
.managedExecution(managedExecution)
.operationPreferences(OperationPreferencesProperty.builder()
.concurrencyMode("concurrencyMode")
.failureToleranceCount(123)
.failureTolerancePercentage(123)
.maxConcurrentCount(123)
.maxConcurrentPercentage(123)
.regionConcurrencyType("regionConcurrencyType")
.regionOrder(List.of("regionOrder"))
.build())
.parameters(List.of(ParameterProperty.builder()
.parameterKey("parameterKey")
.parameterValue("parameterValue")
.build()))
.stackInstancesGroup(List.of(StackInstancesProperty.builder()
.deploymentTargets(DeploymentTargetsProperty.builder()
.accountFilterType("accountFilterType")
.accounts(List.of("accounts"))
.accountsUrl("accountsUrl")
.organizationalUnitIds(List.of("organizationalUnitIds"))
.build())
.regions(List.of("regions"))
// the properties below are optional
.parameterOverrides(List.of(ParameterProperty.builder()
.parameterKey("parameterKey")
.parameterValue("parameterValue")
.build()))
.build()))
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.templateBody("templateBody")
.templateUrl("templateUrl")
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK;
var managedExecution;
var cfnStackSet = new CfnStackSet(this, "MyCfnStackSet", new CfnStackSetProps {
PermissionModel = "permissionModel",
StackSetName = "stackSetName",
// the properties below are optional
AdministrationRoleArn = "administrationRoleArn",
AutoDeployment = new AutoDeploymentProperty {
DependsOn = new [] { "dependsOn" },
Enabled = false,
RetainStacksOnAccountRemoval = false
},
CallAs = "callAs",
Capabilities = new [] { "capabilities" },
Description = "description",
ExecutionRoleName = "executionRoleName",
ManagedExecution = managedExecution,
OperationPreferences = new OperationPreferencesProperty {
ConcurrencyMode = "concurrencyMode",
FailureToleranceCount = 123,
FailureTolerancePercentage = 123,
MaxConcurrentCount = 123,
MaxConcurrentPercentage = 123,
RegionConcurrencyType = "regionConcurrencyType",
RegionOrder = new [] { "regionOrder" }
},
Parameters = new [] { new ParameterProperty {
ParameterKey = "parameterKey",
ParameterValue = "parameterValue"
} },
StackInstancesGroup = new [] { new StackInstancesProperty {
DeploymentTargets = new DeploymentTargetsProperty {
AccountFilterType = "accountFilterType",
Accounts = new [] { "accounts" },
AccountsUrl = "accountsUrl",
OrganizationalUnitIds = new [] { "organizationalUnitIds" }
},
Regions = new [] { "regions" },
// the properties below are optional
ParameterOverrides = new [] { new ParameterProperty {
ParameterKey = "parameterKey",
ParameterValue = "parameterValue"
} }
} },
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} },
TemplateBody = "templateBody",
TemplateUrl = "templateUrl"
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import cdk "github.com/aws/aws-cdk-go/awscdk"
var managedExecution interface{}
cfnStackSet := cdk.NewCfnStackSet(this, jsii.String("MyCfnStackSet"), &CfnStackSetProps{
PermissionModel: jsii.String("permissionModel"),
StackSetName: jsii.String("stackSetName"),
// the properties below are optional
AdministrationRoleArn: jsii.String("administrationRoleArn"),
AutoDeployment: &AutoDeploymentProperty{
DependsOn: []*string{
jsii.String("dependsOn"),
},
Enabled: jsii.Boolean(false),
RetainStacksOnAccountRemoval: jsii.Boolean(false),
},
CallAs: jsii.String("callAs"),
Capabilities: []*string{
jsii.String("capabilities"),
},
Description: jsii.String("description"),
ExecutionRoleName: jsii.String("executionRoleName"),
ManagedExecution: managedExecution,
OperationPreferences: &OperationPreferencesProperty{
ConcurrencyMode: jsii.String("concurrencyMode"),
FailureToleranceCount: jsii.Number(123),
FailureTolerancePercentage: jsii.Number(123),
MaxConcurrentCount: jsii.Number(123),
MaxConcurrentPercentage: jsii.Number(123),
RegionConcurrencyType: jsii.String("regionConcurrencyType"),
RegionOrder: []*string{
jsii.String("regionOrder"),
},
},
Parameters: []interface{}{
&ParameterProperty{
ParameterKey: jsii.String("parameterKey"),
ParameterValue: jsii.String("parameterValue"),
},
},
StackInstancesGroup: []interface{}{
&StackInstancesProperty{
DeploymentTargets: &DeploymentTargetsProperty{
AccountFilterType: jsii.String("accountFilterType"),
Accounts: []*string{
jsii.String("accounts"),
},
AccountsUrl: jsii.String("accountsUrl"),
OrganizationalUnitIds: []*string{
jsii.String("organizationalUnitIds"),
},
},
Regions: []*string{
jsii.String("regions"),
},
// the properties below are optional
ParameterOverrides: []interface{}{
&ParameterProperty{
ParameterKey: jsii.String("parameterKey"),
ParameterValue: jsii.String("parameterValue"),
},
},
},
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
TemplateBody: jsii.String("templateBody"),
TemplateUrl: jsii.String("templateUrl"),
})
Initializer
new CfnStackSet(scope: Construct, id: string, props: CfnStackSetProps)
CfnStackSet(scope: Construct, id: str, props: CfnStackSetProps)
new CfnStackSet(Construct scope, String id, CfnStackSetProps props)
new CfnStackSet(Construct scope, string id, CfnStackSetProps props)
NewCfnStackSet(Scope Construct, Id *string, Props CfnStackSetProps)
Construct Props
administrationRoleArnstring | IRoleRefadministration_role_arntyping.Union[str, IRoleRef]administrationRoleArnStringAdministrationRoleArnstringAdministrationRoleArninterface{}#notes
Specify an IAM role only if you are using customized administrator roles to control which users or groups can manage specific StackSets within the same administrator account.
Use customized administrator roles to control which users or groups can manage specific StackSets within the same administrator account. For more information, see Grant self-managed permissions in the CloudFormation User Guide .
Valid only if the permissions model is SELF_MANAGED .
autoDeploymentIResolvable | CfnStackSet.AutoDeploymentPropertyauto_deploymenttyping.Union[IResolvable, AutoDeploymentProperty]autoDeploymentIResolvableAutoDeploymentIResolvableAutoDeploymentinterface{}#notes
For more information, see Enable or disable automatic deployments for StackSets in AWS Organizations in the CloudFormation User Guide .
Required if the permissions model is SERVICE_MANAGED . (Not used with self-managed permissions.)
notes
By default, SELF is specified. Use SELF for StackSets with self-managed permissions.
- To create a StackSet with service-managed permissions while signed in to the management account, specify
SELF. - To create a StackSet with service-managed permissions while signed in to a delegated administrator account, specify
DELEGATED_ADMIN.
Your AWS account must be registered as a delegated admin in the management account. For more information, see Register a delegated administrator in the CloudFormation User Guide .
StackSets with service-managed permissions are created in the management account, including StackSets that are created by delegated administrators.
Valid only if the permissions model is SERVICE_MANAGED .
capabilitiesstring[]capabilitiestyping.List[str]capabilitiesList<String>Capabilitiesstring[]Capabilities*[]*string#notes
Some StackSet templates might include resources that can affect permissions in your AWS account —for example, by creating new IAM users. For more information, see Acknowledging IAM resources in CloudFormation templates in the CloudFormation User Guide .
executionRoleNamestring | IRoleRefexecution_role_nametyping.Union[str, IRoleRef]executionRoleNameStringExecutionRoleNamestringExecutionRoleNameinterface{}#If you don't specify an execution role, CloudFormation uses the AWSCloudFormationStackSetExecutionRole role for the StackSet operation.
Valid only if the permissions model is SELF_MANAGED .
Pattern : [a-zA-Z_0-9+=,.@-]+
managedExecutionanymanaged_executionAnymanagedExecutionObjectManagedExecutionobjectManagedExecutioninterface{}#notes
When active, StackSets performs non-conflicting operations concurrently and queues conflicting operations. After conflicting operations finish, StackSets starts queued operations in request order.
If there are already running or queued operations, StackSets queues all incoming operations even if they are non-conflicting.
You can't modify your StackSet's execution configuration while there are running or queued operations for that StackSet.
When inactive (default), StackSets performs one operation at a time in request order.
operationPreferencesIResolvable | CfnStackSet.OperationPreferencesPropertyoperation_preferencestyping.Union[IResolvable, OperationPreferencesProperty]operationPreferencesIResolvableOperationPreferencesIResolvableOperationPreferencesinterface{}#parametersIResolvable | IResolvable | CfnStackSet.ParameterProperty[]parameterstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ParameterProperty]]]parametersIResolvableParametersIResolvableParametersinterface{}#permissionModelstringpermission_modelstrpermissionModelStringPermissionModelstringPermissionModel*stringrequired#notes
- With
SELF_MANAGEDpermissions, you must create the administrator and execution roles required to deploy to target accounts. For more information, see Grant self-managed permissions in the CloudFormation User Guide . - With
SERVICE_MANAGEDpermissions, StackSets automatically creates the IAM roles required to deploy to accounts managed by AWS Organizations . For more information, see Activate trusted access for StackSets with AWS Organizations in the CloudFormation User Guide .
stackInstancesGroupIResolvable | IResolvable | CfnStackSet.StackInstancesProperty[]stack_instances_grouptyping.Union[IResolvable, typing.List[typing.Union[IResolvable, StackInstancesProperty]]]stackInstancesGroupIResolvableStackInstancesGroupIResolvableStackInstancesGroupinterface{}#The name must be unique in the Region where you create your StackSet.
notes
CloudFormation also propagates these tags to supported resources in the stack. You can specify a maximum number of 50 tags.
If you don't specify this parameter, CloudFormation doesn't modify the stack's tags. If you specify an empty value, CloudFormation removes all associated tags.
notes
You must include either TemplateURL or TemplateBody in a StackSet, but you can't use both. Dynamic references in the TemplateBody may not work correctly in all cases. It's recommended to pass templates that contain dynamic references through TemplateUrl instead.
notes
The URL must point to a template (max size: 1 MB) that's located in an Amazon S3 bucket or a Systems Manager document. The location for an Amazon S3 bucket must start with https:// .
Conditional: You must specify only one of the following parameters: TemplateBody , TemplateURL .
Properties
administrationRoleArnstringadministration_role_arnstradministrationRoleArnStringAdministrationRoleArnstringAdministrationRoleArn*string#attrStackSetIdstringattr_stack_set_idstrattrStackSetIdStringAttrStackSetIdstringAttrStackSetId*stringrequired#autoDeploymentIResolvable | CfnStackSet.AutoDeploymentPropertyauto_deploymenttyping.Union[IResolvable, AutoDeploymentProperty]autoDeploymentIResolvableAutoDeploymentIResolvableAutoDeploymentinterface{}#capabilitiesstring[]capabilitiestyping.List[str]capabilitiesList<String>Capabilitiesstring[]Capabilities*[]*string#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#executionRoleNamestringexecution_role_namestrexecutionRoleNameStringExecutionRoleNamestringExecutionRoleName*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
managedExecutionanymanaged_executionAnymanagedExecutionObjectManagedExecutionobjectManagedExecutioninterface{}required#operationPreferencesIResolvable | CfnStackSet.OperationPreferencesPropertyoperation_preferencestyping.Union[IResolvable, OperationPreferencesProperty]operationPreferencesIResolvableOperationPreferencesIResolvableOperationPreferencesinterface{}#parametersIResolvable | IResolvable | CfnStackSet.ParameterProperty[]parameterstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ParameterProperty]]]parametersIResolvableParametersIResolvableParametersinterface{}#permissionModelstringpermission_modelstrpermissionModelStringPermissionModelstringPermissionModel*stringrequired#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
stackInstancesGroupIResolvable | IResolvable | CfnStackSet.StackInstancesProperty[]stack_instances_grouptyping.Union[IResolvable, typing.List[typing.Union[IResolvable, StackInstancesProperty]]]stackInstancesGroupIResolvableStackInstancesGroupIResolvableStackInstancesGroupinterface{}#stackSetRefStackSetReferencestack_set_refStackSetReferencestackSetRefStackSetReferenceStackSetRefStackSetReferenceStackSetRefStackSetReferencerequired#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnStackSet(x: any): boolean@staticmethod def is_cfn_stack_set(x: Any) -> boolpublic static Boolean isCfnStackSet(Object x)public static bool IsCfnStackSet(object x)func IsCfnStackSet(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.